@use './session_cell.scss';


.timetable-view {
  display: block;
  border: 1px solid var(--border-secondary-color);
  border-radius: var(--border-radius);

  overflow: auto;
  position: relative;
}
.timetable-view > .grid {
  &{
    height: 100%;
    width: 100%;
    display: grid;
    position: relative;

    --hour-count: 24;

    --day-count: 8;

    grid-template-columns: max-content repeat(var(--hour-count), 1fr);
    grid-template-rows: max-content repeat(var(--day-count), auto);
  }

  & > .cornerCell {
    position: sticky;
    top: 0; left: 0;

    background-color: var(--background-color);
    z-index: 2;
    grid-row: 1; grid-column: 1;
    border-bottom: 1px solid var(--border-secondary-color);
    border-right: 1px solid var(--border-secondary-color);
  }
}

// hours
.timetable-view > .grid {
  & > .hourHeader {
    min-width: 6em;
    width: 1fr;
    grid-row: 1;

    position: sticky;
    top: 0;
    z-index: 1;

    background-color: var(--background-color);
    z-index: 1;
    border-bottom: 1px solid var(--border-secondary-color);

    font-size: 70%;

    & > * {
      margin: 0.3em;
      padding-top: 0.1em;

      transform: translateX(0); // some weird visual error
      display: inline-block;
      background-color: var(--background-color);
    }
    &:not([pos="0"]) > * {
      transform: translateX(-50%);
    }
  }

  & > .hourBody {
    grid-row: 2 / calc(var(--day-count) + 2);
  }

  & > .hourHeader:not([pos="0"]), & > .hourBody:not([pos="0"]) {
    border-left: 1px solid var(--border-secondary-color);
  }
  & > .hourHeader[pos="-1"], & > .hourBody[pos="-1"] {
    display: none;
  }
}

// days
.timetable-view > .grid {
  & > .dayHeader {
    grid-column: 1;

    position: sticky;
    left: 0;
    z-index: 1;

    background-color: var(--background-color);
    border-right: 1px solid var(--border-secondary-color);

    padding: 0.2em;
    font-size: 160%;
    font-weight: bold;

    min-height: 2em;
    min-width: 1.4em;
    display: flex;

    & > * {
      flex-grow: 1;
      align-self: stretch;
      overflow: hidden;
      position: relative;
    }
    & > * > * {
      position: absolute;
      left: 0;
      top: 0;
      height: 100%;
      width: 100%;
      text-transform: capitalize;
      text-align: center;
      writing-mode: vertical-lr;
      transform: rotate(180deg);
    }
  }

  & > .dayBody {
    grid-column: 2 / calc(var(--hour-count) + 2);
    position: relative;
    font-size: 80%;
    padding: 0 0.15em;
  }

  & > .dayHeader:not([pos="0"]), & > .dayBody:not([pos="0"]) {
    border-top: 1px solid var(--border-tertiary-color);
  }
  & > .dayHeader[pos="-1"], & > .dayBody[pos="-1"] {
    display: none;
  }

}
